#!/usr/bin/ruby

require "mistfiles"

class MistFiles
  def create_object(params={})
		auth_if_necessary!
    # Required parameters
    data = params[:data] || params["data"]
    container = params[:container] || params["container"]
    object = params[:object] || params["object"]
    
    # optional parameters
    content_type = params[:content_type] || params["content_type"] # can be detected by Rackspace
    delete_at = (params[:delete_at] || params["delete_at"]).to_i
    delete_after = (params[:delete_after] || params["delete_after"]).to_i
    name = (params[:name] || params["name"])
    
    # TODO: Implement X-Copy-From
    
    headers = {
      "ETag" => Digest::MD5.digest(data)
    }
    
    # Either X-Detect-Content-Type or Content-Type is required
    headers["X-Detect-Content-Type"] = "True" if content_type.nil?
    headers["Content-Type"] = content_type unless content_type.nil?
    headers["X-Object-Meta-name"] = name unless name.nil?
    
    send_request(
      :host => @files_catalog[@region],
      :path => "/#{container}/#{object}",
      :method => :put,
      :body_type => :raw,
      :params => data,
      :headers => headers
    )
  end
	
  # Create and Update are the same
  # Rackspace doesn't have a patch endpoint here
	alias_method :update_object, :create_object
  
  def delete_object(params={})
		auth_if_necessary!
    container = params[:container] || params["container"]
    object = params[:object] || params["object"]
    send_request(
      :host => @files_catalog[@region],
      :path => "/#{container}/#{object}",
      :method => :delete
    )
  end
  
  def get_object(params={})
		auth_if_necessary!
    ontainer = params[:container] || params["container"]
    object = params[:object] || params["object"]
    headers = params[:headers] || params["headers"]
    send_request(
      :host => @files_catalog[@region],
      :path => "/#{container}/#{object}",
      :method => :get,
      :params => params || {},
      :headers => headers,
      :parse_json => false
    )
  end
end